/****************************************************************************
* NVMC                                                                      *
* EnVy My Car																*
*                                                                           *
* Fabio Ganovelli                                                           *
* Massimiliano Corsini                                                      *
*                                                                           *
* All rights reserved.                                                      *
*                                                                           *
* This program is free software; you can redistribute it and/or modify      *
* it under the terms of the GNU General Public License as published by      *
* the Free Software Foundation; either version 2 of the License, or         *
* (at your option) any later version.                                       *
*                                                                           *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
* GNU General Public License (http://www.gnu.org/licenses/gpl.txt)          *
* for more details.                                                         *
*                                                                           *
****************************************************************************/


#include "client_game.h"
#include "race.h"
#include "glwidget.h"

// Qt headers
#include <QApplication>
#include <QDialog>
#include <QTimer>

int launch_viewer()
{
    int argc=0;
    QApplication app(argc, NULL);

    // inizializzazione widget Qt
    QDialog dlg;
    GLWidget *glwidget = new GLWidget(&dlg);
    glwidget->setFixedSize(600,600);

    QObject::connect(&app, SIGNAL(lastWindowClosed()), &app, SLOT(quit()));

    // update the display every 50 milliseconds
    QTimer *timer = new QTimer(&dlg);
    QObject::connect(timer, SIGNAL(timeout()), glwidget, SLOT(repaint()));
    timer->start(50);

    dlg.setModal(true);
    dlg.exec();

    return 0;
}
