#ifndef _NVMC_PACKAGING_
#define _NVMC_PACKAGING_
/****************************************************************************
* NVMC                                                                      *
* EnVy My Car																*
*                                                                           *
* Fabio Ganovelli                                                           *
*                                                                           *
* All rights reserved.                                                      *
*                                                                           *
* This program is free software; you can redistribute it and/or modify      *
* it under the terms of the GNU General Public License as published by      *
* the Free Software Foundation; either version 2 of the License, or         *
* (at your option) any later version.                                       *
*                                                                           *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
* GNU General Public License (http://www.gnu.org/licenses/gpl.txt)          *
* for more details.                                                         *
*                                                                           *
****************************************************************************/


#include "messages.h"
#include <frame.h>

 
/**@name Packaging
* these function convert Messages to string and string to messages
*/
//@{ 
///pack a frame into a string
std::string Pack(const Frame & frame);
///pack a float into a string
std::string Pack(const  float & v);
/// unpack a string containint a frame in a C2SMessage
C2SMessage UnPack(const std::string & mess);
/// pack a C2SMessage message in a string
std::string Pack(const C2SMessage & mess);
/// pack a vcg::Point4f in a string
std::string Pack(const  vcg::Point4f & f);
/// pack an integer in a string
std::string Pack(const int & v);
//@}
#endif
