#ifndef _NVMC_PLAYER_
#define _NVMC_PLAYER_
/****************************************************************************
* NVMC                                                                      *
* EnVy My Car																*
*                                                                           *
* Fabio Ganovelli                                                           *
*                                                                           *
* All rights reserved.                                                      *
*                                                                           *
* This program is free software; you can redistribute it and/or modify      *
* it under the terms of the GNU General Public License as published by      *
* the Free Software Foundation; either version 2 of the License, or         *
* (at your option) any later version.                                       *
*                                                                           *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
* GNU General Public License (http://www.gnu.org/licenses/gpl.txt)          *
* for more details.                                                         *
*                                                                           *
****************************************************************************/



#include <car.h>
#include "messages.h"
#include "screenshot.h"
#include <QHostAddress>

/** a player owns a car plus attributes such as pausing, withdrawn etc.. */
struct Player{

	/** constructor */
	Player(){}

	/** copy constructor*/
 	Player(const Player & p){ car = p.car;ip_address = p.ip_address;state = p.state; screenshot = p.screenshot; last_updated = p.last_updated; }

	/** destructor */
	~Player(){}

	void operator=(const Player & p){ car = p.car;ip_address = p.ip_address; state = p.state;last_updated = p.last_updated;}

	/** boolean attributes*/
	enum {
		PLAYING  = 0x001, // it's running or pausing
		PAUSING  = 0x002, // it's pausing
		WAITING  = 0x004, // ready and waiting to run
		WITHDRAWN= 0x008, // withdrawn
		BRAKING  = 0x010, // it is braking
		BOOSTING = 0x020  // it is boosting
	};
	/** state of the player */
	int state;

	/** the player's car*/
	Car car;

	/** ip address of the player */
	QHostAddress ip_address; 

	/** current screenshot of the player */
	Screenshot screenshot;

	/** mutex on the player data	 */
	QMutex  mutex_on_data;

	/** last time data where sent to the id	 */
	int last_sent;

	/** last time data was updated	 */
	int last_updated;

};


#endif
