#ifndef VCGMESH_H
#define VCGMESH_H

#include <vector>

// base definition for the vertex
#include <vcg/simplex/vertex/base.h>

// base definition for the face
#include <vcg/simplex/face/base.h>

// base definition for the trimesh
#include <vcg/complex/trimesh/base.h>

using namespace vcg;
using namespace std;

class VCGEdge;    // dummy prototype never used
class VCGFace;

/* define a vertex passing the desired attributes. Each attributes has its own class.
Check vcg/simplex/vertexplus/component.h to find out the existing attributes. */
class VCGVertex : public VertexSimp2< VCGVertex, VCGEdge, VCGFace, vertex::Coord3f, vertex::Normal3f >{};

/*same as for the vertes */
class VCGFace   : public FaceSimp2<   VCGVertex, VCGEdge, VCGFace, face::VertexRef, face::Normal3f > {};

/*the mesh is a container of vertices and a container of faces */
class VCGMesh   : public vcg::tri::TriMesh< vector<VCGVertex>, vector<VCGFace> > {};


#endif // VCGMESH_H
